#include<bits/stdc++.h>
#include "secret.h"
using namespace std;
int ans[1024][1024];
int n,a[1024],p[1024];
void calc(int l,int r)
{
    int mid=(l+r)/2;
    p[mid-1]=a[mid-1];
    for(int i=mid-2;i>=l;i--)
        p[i]=Secret(p[i+1],a[i]);
    p[mid+1]=a[mid+1];
    for(int i=mid+2;i<=r;i++)
        p[i]=Secret(p[i-1],a[i]);
}
void divide(int l,int r)
{
    if(l>r)return;
    //cout<<l<<" "<<r<<endl;
    if(l==r)
    {
        ans[l][r]=a[l];
        return;
    }
    int mid=(l+r)/2;
    calc(l,r);
    for(int i=l;i<=mid;i++)
    {
        for(int j=mid;j<=r;j++)
        {
            if(i==mid&&j==mid)
            {
                ans[i][j]=a[mid];
                continue;
            }
            if(i==mid)
            {
                ans[i][j]=Secret(a[i],p[j]);
                continue;
            }
            if(j==mid)
            {
                ans[i][j]=Secret(a[j],p[i]);
                continue;
            }
            int sides=Secret(p[i],p[j]);
            ans[i][j]=Secret(sides,a[mid]);
        }
    }
    divide(l,mid);
    divide(mid+1,r);
}
void Init(int N, int A[])
{
    n=N;
    for(int i=0;i<n;i++)
        a[i]=A[i];
    divide(0,n-1);
}
int query(int l,int r,int ql,int qr)
{
    if(ql>qr)return -1;
    if(ql<=l&&r<=qr)return ans[l][r];
    int mid=(l+r)/2;
    int val1=query(l,mid,ql,min(qr,mid));
    int val2=query(mid+1,r,max(mid+1,ql),qr);
    if(val1==-1)return val2;
    if(val2==-1)return val1;
    return Secret(val1,val2);
}
int Query(int l,int r)
{
    return query(0,n-1,l,r);
}
