#include "secret.h"
#include<bits/stdc++.h>
using namespace std;

int pr[10][1000];
int su[10][1000];

void Init(int n, int a[]) {
    for(int i = 0; i < n; i++) {
        pr[0][i] = a[i];
        su[0][i] = a[i];
    }
    for(int i = 1; i < 10; i++) {
        for(int j = 0; j < n; j++) {
            if(j%(1 << i) < (1 << (i-1))) {
                pr[i][j] = pr[i-1][j];
            }
            else {
                pr[i][j] = Secret(pr[i][j-1],a[j]);
            }
        }
    }
    for(int i = 1; i < 10; i++) {
        for(int j = n-1; j >= 0; j--) {
            if(j%(1 << i) >= (1 << (i-1))) {
                su[i][j] = su[i-1][j];
            }
            else {
                su[i][j] = Secret(a[j],su[i][j+1]);
            }
        }
    }
}

int Query(int l, int r) {
    if(l == r) {
        return pr[0][l];
    }
    for(int i = 10; i >= 0; i--) {
        if(l/(1 << i) != r/(1 << i)) {
            return Secret(su[i][l],pr[i][r]);
        }
    }
    return 0;
}
