#include "secret.h"
#include <bits/stdc++.h>
#define endl "\n"

using namespace std;

const int maxn = 1024;
int n,a[maxn];
int pref[maxn][16],suff[maxn][16];
int ql,qr,ans;

void divide(int l, int r, int lvl)
{
    if(l>r) return;
    int mid = (l+r)/2;
    pref[mid][lvl] = a[mid];
    if(mid+1<=r) suff[mid+1][lvl] = a[mid+1];
    for(int i=mid-1;i>=l;i--) pref[i][lvl] = Secret(a[i],pref[i+1][lvl]);
    for(int i=mid+2;i<=r;i++) suff[i][lvl] = Secret(suff[i-1][lvl],a[i]);
    divide(l,mid-1,lvl+1);
    divide(mid+1,r,lvl+1);
}

void query(int l, int r, int lvl)
{
    if(l>r) return;
    int mid = (l+r)/2;
    if(ql<=mid&&mid<=qr)
    {
        ans = pref[ql][lvl];
        if(qr!=mid) ans = Secret(ans,suff[qr][lvl]);
        return;
    }
    if(qr<mid) query(l,mid-1,lvl+1);
    else query(mid+1,r,lvl+1);
}

int Query(int L, int R)
{
    ql = L+1;
    qr = R+1;
    query(1,n,1);
    return ans;
}

void Init(int N, int A[])
{
    n = N;
    for(int i=1;i<=n;i++) a[i] = A[i-1];
    divide(1,n,1);
}
