#include <bits/stdc++.h>

using namespace std;

const int maxn = 1005;
const int max_sum = 20005;
const int inf = 1000000007;

int n, sum = 0;
int a[maxn];

int dp[maxn][max_sum];

void fastIO()
{
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
}

int main()
{
    fastIO();

    cin >> n;

    for (int i = 1; i <= n; ++i)
    {
        cin >> a[i];
        sum += a[i];
    }

    if (sum % 2 == 1)
    {
        cout << -1 << endl;
        return 0;
    }

    for (int i = 1; i <= sum; ++i)
    {
        dp[0][i] = inf;
    }

    dp[0][0] = 0;

    for (int i = 1; i <= n; ++i)
    {
        for (int j = 0; j <= sum; ++j)
        {
            dp[i][j] = dp[i - 1][j];

            if (j >= a[i] && dp[i - 1][j - a[i]] != inf)
            {
                dp[i][j] = min(dp[i][j], 1 + dp[i - 1][j - a[i]]);
            }
        }
    }

    if (dp[n][sum / 2] == inf)
    {
        cout << -1 << endl;
        return 0;
    }

    int sz1 = dp[n][sum / 2];
    int sz2 = n - sz1;

    cout << sz2 - sz1 << endl;

    return 0;
}
