#include <bits/stdc++.h>

using namespace std;

const int maxn = 10005;
const int max_sum = 500005;
const int inf = 1000000007;
const int max_number = 205;

int n, sum = 0;
int a[maxn];

int dp[2][max_sum];

int cnt[max_number];

void fastIO()
{
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
}

int main()
{
    fastIO();

    cin >> n;
    int mx = 0;

    for (int i = 1; i <= n; ++i)
    {
        cin >> a[i];
        sum += a[i];
        ++cnt[a[i]];
        mx = max(mx, a[i]);
    }

    if (sum % 2 == 1)
    {
        cout << -1 << endl;
        return 0;
    }

    vector<pair<int, int>> v;

    for (int i = 1; i <= mx; ++i)
    {
        if (cnt[i] == 0)
        {
            continue;
        }

        int num = cnt[i];

        int pwr = 1;

        while (pwr < num)
        {
            v.push_back(make_pair(pwr * i, pwr));
            num -= pwr;
            pwr *= 2;
        }

        if (num != 0)
        {
            v.push_back(make_pair(num * i, num));
        }
    }

    for (int i = 1; i <= sum; ++i)
    {
        dp[0][i] = inf;
    }

    dp[0][0] = 0;

    int sz = v.size();

    for (int i = 1; i <= sz; ++i)
    {
        int curr = (i & 1);
        int prv = 1 - curr;
        int num = v[i - 1].first;
        int coeff = v[i - 1].second;

        for (int j = 0; j <= sum; ++j)
        {
            dp[curr][j] = dp[prv][j];

            if (j >= num && dp[prv][j - num] != inf)
            {
                dp[curr][j] = min(dp[curr][j], coeff + dp[prv][j - num]);
            }
        }
    }

    if (dp[(sz & 1)][sum / 2] == inf)
    {
        cout << -1 << endl;
        return 0;
    }

    int sz1 = dp[(sz & 1)][sum / 2];
    int sz2 = n - sz1;

    cout << sz2 - sz1 << endl;

    return 0;
}
