#include <bits/stdc++.h>

using namespace std;

const int maxn = 5005;

int n;
bool possible[maxn][maxn];
string s;

void fastIO()
{
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
}

int main()
{
    fastIO();

    cin >> s;
    n = s.size();

    int balance = 0;
    int depth = 0;

    for (int i = 0; i < n; ++i)
    {
        if (s[i] == '(')
        {
            ++balance;
        }
        else
        {
            --balance;
        }

        depth = max(depth, abs(balance));
    }

    if (depth >= 2)
    {
        cout << 0 << endl;
        return 0;
    }

    int ans = 0;

    for (int i = 0; i <= n; ++i)
    {
        string result = "";

        for (int j = 0; j < i; ++j)
        {
            result.push_back(s[j]);
        }

        result.push_back('(');

        for (int j = i; j < n; ++j)
        {
            result.push_back(s[j]);
        }

        for (int j = 0; j <= result.size(); ++j)
        {
            string to_check = "";

            for (int k = 0; k < j; ++k)
            {
                to_check.push_back(result[k]);
            }

            to_check.push_back(')');

            for (int k = j; k < result.size(); ++k)
            {
                to_check.push_back(result[k]);
            }

            bool ok = true;
            int balance = 0;

            for (int k = 0; k < to_check.size(); ++k)
            {
                if (to_check[k] == '(')
                {
                    ++balance;
                }
                else
                {
                    if (balance <= 0)
                    {
                        ok = false;
                        break;
                    }

                    --balance;
                }
            }

            if (balance != 0 && ok == true)
            {
                ok = false;
            }

            if (ok == true)
            {
                ++ans;
            }
        }
    }

    cout << ans << endl;

    return 0;
}
