#include <bits/stdc++.h>
#pragma GCC optimize("O2")
#pragma GCC optimize("unroll-loops")
#pragma GCC target("avx2")

using namespace std;

int n;
string s;

unordered_map<string, int> precomp;

void fastIO()
{
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
}

int main()
{
    fastIO();

    cin >> s;
    n = s.size();

    int ans = 0;

    for (int i = 0; i <= n; ++i)
    {
        string result = "";

        for (int j = 0; j < i; ++j)
        {
            result.push_back(s[j]);
        }

        result.push_back('(');

        for (int j = i; j < n; ++j)
        {
            result.push_back(s[j]);
        }

        if (precomp.find(result) != precomp.end())
        {
            ans += precomp[result];
            continue;
        }

        int balance = 0;
        stack<int> st;

        for (int j = 0; j < result.size(); ++j)
        {
            if (result[j] == '(')
            {
                ++balance;
                st.push(j);
            }
            else
            {
                if (!st.empty())
                {
                    st.pop();
                }

                --balance;
            }
        }

        if (balance == +1)
        {
            int start = st.top();
            ans += result.size() - start;
            precomp[result] = result.size() - start;
        }
    }

    cout << ans << endl;

    return 0;
}
