#include <bits/stdc++.h>
#include "secret.h"
#define endl '\n'

using namespace std;

const int maxn = 1e3 + 1;
long long matrix[maxn][maxn], A[maxn];

void Init(int n, int a[]){
    for(int i = 1;i <= n;i++){
        matrix[i][0] = a[i];
        A[i] = a[i];
    }
    for(int j = 1;j < 8;j++){
        for(int i = 1;i <= n;i++){
            matrix[i][j] = Secret(matrix[i][j - 1], matrix[i + (1 << (j - 1))][j - 1]);
        }
    }
}

int Query(int lf, int rg){
    long long ans = A[lf], i;
    for(i = lf + 1;i + 1 <= rg;i += 2)
        ans = Secret(ans, Secret(A[i], A[i + 1]));
    if(i == rg)
        ans = Secret(ans, A[rg]);
    return ans;
}
