#include <bits/stdc++.h>
#include "secret.h"
#define endl '\n'

using namespace std;

const int maxn = 1e3 + 1;
long long matrix[maxn][maxn];

void Init(int n, int a[]){
    for(int i = 0;i < n;i++)
        matrix[i][0] = a[i];
    for(int j = 1;j < 8;j++){
        for(int i = 0;i < n;i++){
            if(i + (1 << j) - 1 < n)
                matrix[i][j] = Secret(matrix[i][j - 1], matrix[i + (1 << (j - 1))][j - 1]);
        }
    }
}

int Query(int lf, int rg){
    int len = rg - lf + 1;
    long long ans = -1;
    for(int i = 7;i >= 0;i--){
        while(len >= (1 << i)){
            if(ans == -1)
                ans = matrix[lf][i];
            else{
                ans = Secret(ans, matrix[lf][i]);
            }
            lf += (1 << i);
            len -= (1 << i);
        }
    }
    return ans;
}
