#include "secret.h"
#include <bits/stdc++.h>
#define endl "\n"

using namespace std;

const int maxn = 1024;
int n,a[maxn];
int tree[4*maxn];
int ql,qr;

void make_tree(int v, int l, int r)
{
    if(l==r)
    {
        tree[v] = a[r];
        return;
    }
    int mid = (l+r)/2;
    make_tree(v*2+0,l,mid+0);
    make_tree(v*2+0,mid+1,r);
    tree[v] = Secret(tree[v*2+0],tree[v*2+1]);
}

int query(int v, int l, int r)
{
    if(l>r||r<ql||qr<l) return -1;
    if(ql<=l&&r<=qr) return tree[v];
    int mid = (l+r)/2;
    int ch1 = query(v*2+0,l,mid+0);
    int ch2 = query(v*2+1,mid+1,r);
    if(ch1==-1) return ch2;
    if(ch2==-1) return ch1;
    return Secret(ch1,ch2);
}

int Query(int L, int R)
{
    ql = L;
    qr = R;
    ql++;
    qr++;
    return query(1,1,n);
}

void Init(int N, int A[])
{
    n = N;
    for(int i=1;i<=n;i++) a[i] = A[i-1];
    for(int i=1;i<=n;i++) cout << a[i] << " ";
    cout << endl;
    make_tree(1,1,n);
}
