#include <bits/stdc++.h>

using namespace std;

const int maxn = 10005;
const int max_sum = 500005;
const int inf = 1000000007;
const int max_number = 205;

int n, sum = 0;
int a[maxn];

int cnt[max_number];

vector<pair<int, int>> compressed;

map<pair<int, int>, int> dp;

int f(int pos, int sum)
{
    if (pos == compressed.size())
    {
        if (sum == 0)
        {
            return 0;
        }

        return inf;
    }

    if (sum == 0)
    {
        return 0;
    }

    if (dp.find(make_pair(pos, sum)) != dp.end())
    {
        return dp[make_pair(pos, sum)];
    }

    int result = f(pos + 1, sum);

    if (sum >= compressed[pos].first)
    {
        result = min(result, compressed[pos].second + f(pos + 1, sum - compressed[pos].first));
    }

    return dp[make_pair(pos, sum)] = result;
}

void fastIO()
{
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
}

int main()
{
    fastIO();

    cin >> n;
    int mx = 0;

    for (int i = 1; i <= n; ++i)
    {
        cin >> a[i];
        sum += a[i];
        ++cnt[a[i]];
        mx = max(mx, a[i]);
    }

    if (sum % 2 == 1)
    {
        cout << -1 << endl;
        return 0;
    }

    for (int i = 1; i <= mx; ++i)
    {
        if (cnt[i] == 0)
        {
            continue;
        }

        int num = cnt[i];

        int pwr = 1;

        while (pwr < num)
        {
            compressed.push_back(make_pair(pwr * i, pwr));
            num -= pwr;
            pwr *= 2;
        }

        if (num != 0)
        {
            compressed.push_back(make_pair(num * i, num));
        }
    }

    int sz1 = f(0, sum / 2);

    if (sz1 >= inf)
    {
        cout << -1 << endl;
    }
    else
    {
        cout << n - 2 * sz1 << endl;
    }

    return 0;
}
