#include <bits/stdc++.h>

using namespace std;

const int maxn = 1000005;
const int max_sum = 500005;
const int inf = 1000000007;
const int max_number = 205;

int n, sum = 0;
int a[maxn];

vector<pair<int, int>> compressed;

int cnt[max_number];

map<pair<int, int>, int> dp;

int f(int pos, int balance)
{
    if (pos == compressed.size())
    {
        if (balance == 0)
        {
            return 0;
        }

        return inf;
    }

    if (dp.find(make_pair(pos, balance)) != dp.end())
    {
        return dp[make_pair(pos, balance)];
    }

    int result = inf;
    result = min(result, compressed[pos].second + f(pos + 1, balance + compressed[pos].first));
    result = min(result, f(pos + 1, balance - compressed[pos].first));

    return dp[make_pair(pos, balance)] = result;
}

void fastIO()
{
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
}

int main()
{
    fastIO();

    cin >> n;
    int mx = 0;

    for (int i = 1; i <= n; ++i)
    {
        cin >> a[i];
        sum += a[i];
        ++cnt[a[i]];
        mx = max(mx, a[i]);
    }

    if (sum % 2 == 1)
    {
        cout << -1 << endl;
        return 0;
    }

    for (int i = 1; i <= mx; ++i)
    {
        if (cnt[i] == 0)
        {
            continue;
        }

        int num = cnt[i];

        int pwr = 1;

        while (pwr < num)
        {
            compressed.push_back(make_pair(pwr * i, pwr));
            num -= pwr;
            pwr *= 2;
        }

        if (num != 0)
        {
            compressed.push_back(make_pair(num * i, num));
        }
    }

    int ans = f(0, 0);

    if (ans >= inf)
    {
        cout << -1 << endl;
    }
    else
    {
        cout << n - 2 * ans << endl;
    }

    return 0;
}
