#include <bits/stdc++.h>

using namespace std;

int n;
string s;

unordered_map<string, int> precomp;

void fastIO()
{
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
}

int main()
{
    fastIO();

    cin >> s;
    n = s.size();

    int bal = 0;
    int depth = 0;

    for (int i = 0; i < s.size(); ++i)
    {
        if (s[i] == '(')
        {
            ++bal;
        }
        else
        {
            --bal;
        }

        depth = max(depth, abs(bal));
    }

    if (bal >= 2)
    {
        cout << 0 << endl;
        return 0;
    }

    int ans = 0;

    for (int i = 0; i <= n; ++i)
    {
        string result = "";

        for (int j = 0; j < i; ++j)
        {
            result.push_back(s[j]);
        }

        result.push_back('(');

        for (int j = i; j < n; ++j)
        {
            result.push_back(s[j]);
        }

        if (precomp.find(result) != precomp.end())
        {
            ans += precomp[result];
            continue;
        }

        int balance = 0;
        int idx = 0;

        for (int j = 0; j < result.size(); ++j)
        {
            if (result[j] == '(')
            {
                ++balance;

                if (balance == 1)
                {
                    idx = j;
                }
            }
            else
            {
                --balance;
            }
        }

        if (balance == +1)
        {
            ans += result.size() - idx;
            precomp[result] = result.size() - idx;
        }
    }

    cout << ans << endl;

    return 0;
}
