#include "secret.h"

const long long MAX_N = 1001;

int n;
int a[MAX_N];

int tree[MAX_N * 3];

int initi (int ind, int l, int r) {
    if (tree[ind] != -1) return tree[ind];
    if (l == r) return tree[ind] = a[l];
    
    int mid = (l + r) / 2;
    int a = initi(ind * 2, l, mid);    
    int b = initi(ind * 2 + 1, mid + 1, r);

    return tree[ind] = Secret(a, b);
}

int ans (int ind, int l, int r, int tl, int tr) {
    if (r < tl || l > tr) return -1; 
    if (l >= tl && r <= tr) return tree[ind];
    
    int mid = (l + r) / 2;
    int a = ans (ind * 2, l, mid , tl, tr);
    int b = ans (ind * 2 + 1, mid + 1, r, tl, tr);
    if (a == -1) return b;
    if (b == -1) return a;
    return Secret(a, b);
}

void Init(int N, int A[]) {
    n = N;
    for (int i = 0; i < n; i ++) {
        a[i] = A[i];
    }
    for (int i = 0; i <= n * 3; i ++) {
        tree[i] = -1;
    }
    initi(1, 0, n - 1);
}

int Query(int L, int R) {
    return ans(1, 0, n - 1, L, R);
}
