#include <iostream>
using namespace std;

const int s = 201;

int price[s];
int coinsUsed[200000501];
int timesUsedCoin[200000501];

int main () {
	ios_base::sync_with_stdio(0);
	cin.tie(0);
//	cout.tie(0);

	int n, goalPrice = 0;
	cin >> n;

	for (int i = 0; i < n; i++) {
		int temp;
		cin >> temp;
		price[temp]++;
		goalPrice += temp;
	}
	if (goalPrice % 2 == 1) {
		cout << "-1";
		return 0;
	}
	goalPrice /= 2;

	for (int i = 0; i <= goalPrice; i++) {
		coinsUsed[i] = -1;
	}
	coinsUsed[0] = 0;

	for (int i = 0; i < s; i++) {
		if (price[i] == 0) {
			continue;
		}
		for (int j = 0; j < goalPrice; j++) {
			if (coinsUsed[j] == -1) {
				continue;
			}

			if (timesUsedCoin[j] < price[i]) {
				if (coinsUsed[j + i] == -1 || coinsUsed[j + i] > coinsUsed[j] + 1) {
					coinsUsed[j + i] = coinsUsed[j] + 1;
					timesUsedCoin[j + i] = timesUsedCoin[j] + 1;
				}
			}
			timesUsedCoin[j] = 0;
		}
	}
	cout << abs(n - (2 * coinsUsed[goalPrice]));
}
